#!/usr/bin/python

import iml3
import urllib
import cgi
import os
import libxml2
import re
import ipcheck
from mod_python import apache

def handler(req, xml):
	if not ipcheck.check(req.get_remote_host(apache.REMOTE_NOLOOKUP)):
		raise RuntimeError("Используйте локальный адрес для редактирования")
	if (req.args == None):
		raise RuntimeError("Bad query string")
	args = cgi.parse_qs(req.args, keep_blank_values = True, strict_parsing = True)
	dn = urllib.unquote(args["dn"][0])

	help = urllib.unquote(args["type"][0])
	if help != "z80":
		raise RuntimeError("Unknown helper type: %s" % help)

	iml = iml3.IMLDB()
	local = iml.query(dn)

	if not args.has_key("url"):
		xml.data("<iml:helper action='helper.py' dn='%s' type='%s'/>\n" % (dn, help))
		xml.data("<ssx:center>\n")
		xml.data("<a target='_blank' href='http://z80.gz-net.ru/Films/Search.aspx?Title=%s'>z80</a>\n" % local.cn)
		xml.data("</ssx:center>\n")
		return

	url = urllib.unquote(args["url"][0])
	z80 = "http://z80.gz-net.ru"

	if url[0:len(z80)] != z80:
		raise RuntimeError("Bad url: %s" % url)

	data = ""
	if help == "z80":
		pipe = os.popen("/home/psha/public_html/iml3/z80/z80.sh %s" % url)
		data = pipe.read()
		pipe.close()

	doc = libxml2.parseDoc(data)

	root = doc.getRootElement()
	n = root.children
	while n:
		if n.type != "element" or n.name != "title":
			n = n.next
			continue
		title = re.compile("([^(]+)( \((.*)\))? \[(\d+)\]")
		m = title.match(n.content)
		if not m:
			break
		(t_orig, drop, t_ru, year) = m.groups()
		if not t_ru:
			n.unlinkNode()
			n.freeNode()
		else:
			n.setContent(t_ru)
		root.newChild(root.ns(), "year", year)
		root.newChild(root.ns(), "title", urllib.quote(t_orig)).newProp("main", "main")

		break

	film = iml3.IMLFilm([], xml = root)

	xml.data("<ssx:script src='iml3.js'/>\n")
	xml.push("iml:helper-table")

	#iml = iml3.IMLDB()
	#film = iml.query(dn)
	xml.push("iml:helper-row", "type='master'")
	xml.data(local.xml(mode = "edit"))
	xml.pop("iml:helper-row")
	xml.push("iml:helper-row", "type='slave'")
	if film:
		xml.data(film.xml(mode = "edit-slave"))
		#xml.data("<a target='_blank' href='http://z80.gz-net.ru/Films/Search.aspx?Title=%s'>z80</a>\n" % film.cn)
		#xml.data("<ssx:title>iml3: %s</ssx:title>\n" % film.cn)
	else:
		xml.data("<ssx:line>Helper information not found</ssx:line>\n")
	xml.pop("iml:helper-row")
	xml.pop("iml:helper-table")
	#xml.data("<iml:search action='search.py'>фильм</iml:search>\n")
